// [0,   1,  2,  3,  4,  5,  6,  7]
// [8,   9, 10, 11, 12, 13, 14, 15]
// [16, 17, 18, 19, 20, 21, 22, 23]
// [24, 25, 26, 27, 28, 29, 30, 31]
// [32, 33, 34, 35, 36, 37, 38, 39]
// [40, 41, 42, 43, 44, 45, 46, 47]
// [48, 49, 50, 51, 52, 53, 54, 55]
// [56, 57, 58, 59, 60, 61, 62, 63]


window.global = {
    versions: {
        operator: 0,
        appStore: 1,
        HTML: 2
    },
    version: 1,

    orientations: {
        portrait: 0,
        landscape: 1
    },
    orientation: 0,

    gameVersions: ["1.0.1", "1.0.1", "1.0.1"],

    resolution: "700x1440",

    resolutions: [
        // Lowest to highest resolution.
        // {
        //     w: 480,
        //     h: 800,
        //     folder: "480x800"
        // }
        // ,
        {
            w: 700,
            h: 1440,
            folder: "700x1440"
        }
    ],

    musicPlaying: null,

    enviroments: {
        test: 0,
        deploy: 1
    },

    enviroment: 1,

    screen: -1,

    inGameListener: false,
    inMenuListener: false,

    managers: {},

    storage: {
        name: "st_inl_",

        data: {
            tutorial: '',

            board: null,
            lastGameAi: null,
            lastPlayer: null,

            historyMoves: null,
            removedCheckers: null,
            historyBoardOfValues: null,

            captureBackwards: null,
            capture: null,
            king: null,
            kingPriority: null,

            language: null,
            playAs: null,
            stonesSkin: null,
            boardSkin: null,
            highlight: null,
            music: true,
            sounds: true
        }
    },

    fonts: {
        big: "40px saira_medium",
        main: "30px saira_medium",
        small: "20px saira_medium"
    },

    preloader: {
        logoFadeTime: 500,
        splashTime: 1500
    },

    game: {
        self: null
    },

    times: {
        TOP_CHECKERS_TWEEN_TIME: 300,
        TUTORIAL_HAND_TIME: 1000,
        MUSIC_FADE: 1250
    },

    particleAmount: 15,

    //--------------------------------------------------------------------

    timers: [],

    //TODO: kick unused timers
    createTimer: function(delay, callback) {
        var timer = this.phaser.time.create();
        timer.add(delay, callback, this);

        global.timers.push(timer);
        timer.start();
    },


    setPauseState: function setPauseState(paused) {
        var timers = this.timers;
        for (var i = 0; i < timers.length; i++) {
            if (!timers[i].expired) {
                if (paused) {
                    timers[i].pause();
                } else {
                    timers[i].resume();
                }
            }
        }

        var tweens = this.phaser.tweens.getAll();
        for (var i = 0; i < tweens.length; i++) {
            if (paused) {
                tweens[i].pause();
            } else {
                tweens[i].resume();
            }
        }
    },

    //--------------------------------------------------------------------

    playboard: null,

    customBoard: [
        [, , , , , 10, , 2],
        [2, , 2, , , , 2, ],
        [, 2, , , , , , 2],
        [2, , 2, , , , 2, ],
        [, 10, , 10, , 10, , 10],
        [, , , , , , 20, ],
        [, , , , , 10, , ],
        [1, , , , , , , ]
    ],

    boardForGraph: null,

    createBoardForGraph: function() {
        var board = [
            [],
            [],
            [],
            [],
            [],
            [],
            [],
            []
        ];
        var i = 0;
        for (var row = 0; row < 8; row++) {
            for (var col = 0; col < 8; col++) {
                board[row][col] = i;
                i++;
            }
        }
        this.boardForGraph = board;
    },

    cornerPos: ["1", "3", "5", "7", "8", "24", "40", "56", "58", "60", "63", "62", "55", "39", "23"],

    getRowAndColFromGraph: function(number) {
        return [Math.floor(number / 8), number % 8];
    },

    getBetweenGraphBoard: function getBetweenGraphBoard(first, second) {
        return (Number(first) + Number(second)) / 2;
    },

    getSidePossitionsFromGraph: function getSidePossitionsFromGraph(graphPos) {
        if (this.isFloat(graphPos)) {
            return [];
        }

        var rc = this.getRowAndColFromGraph(graphPos);

        var p1 = this.boardForGraph[rc[0] + 1][rc[1] + 1];
        var p2 = this.boardForGraph[rc[0] - 1][rc[1] - 1];
        var p3 = this.boardForGraph[rc[0] + 1][rc[1] - 1];
        var p4 = this.boardForGraph[rc[0] - 1][rc[1] + 1];

        return [p1, p2, p3, p4];

    },

    createHelper2DBoard: function() {
        var board = [
            [],
            [],
            [],
            [],
            [],
            [],
            [],
            []
        ];
        var startRowWithWhite = false;
        for (var row = 0; row < 8; row++) {
            if (startRowWithWhite) {
                startRowWithWhite = false;
            } else {
                startRowWithWhite = true;
            }
            for (var col = 0; col < 8; col++) {
                if (startRowWithWhite) {
                    if (col % 2 === 0) {
                        board[row][col] = 0;
                    } else {
                        board[row][col] = 1;
                    }
                } else {
                    if (col % 2 === 0) {
                        board[row][col] = 1;
                    } else {
                        board[row][col] = 0;
                    }
                }
            }
        }
        this.playboard = board;
    },

    simpleOverjump: function simpleOverjump(from, to) {
        var from = this.getRowAndColFromGraph(from);

        var p1 = false;
        var p2 = false;
        var p3 = false;
        var p4 = false;

        if (from[0] + 2 <= 7 && from[1] + 2 <= 7) {
            p1 = this.boardForGraph[from[0] + 2][from[1] + 2] == to;
        }

        if (from[0] - 2 >= 0 && from[1] + 2 <= 7) {
            p2 = this.boardForGraph[from[0] - 2][from[1] - 2] == to;
        }

        if (from[0] + 2 <= 7 && from[1] - 2 >= 0) {
            p3 = this.boardForGraph[from[0] + 2][from[1] - 2] == to;
        }

        if (from[0] - 2 >= 0 && from[1] - 2 >= 0) {
            p4 = this.boardForGraph[from[0] - 2][from[1] + 2] == to;
        }

        return (p1 || p2 || p3 || p4);
    },

    //--------------------------------------------------------------------

    rules: {
        captureBackwards: false,
        capture: 0,
        king: 2,
        kingPriority: true,
        aiLevel: 0
    },

    setRules1: function setRules1(captureBackwards) {
        this.rules.captureBackwards = captureBackwards;
    },
    setRules2: function setRules2(capture) {
        this.rules.capture = capture;
    },
    setRules3: function setRules3(king) {
        this.rules.king = king;
    },
    setRules4: function setRules4(kingPriority) {
        this.rules.kingPriority = kingPriority;
    },

    //--------------------------------------------------------------------

    settings: {
        language: 0,
        playAs: 0,
        stonesSkin: 0,
        boardSkin: 0,
        highlight: true,
        music: true,
        sounds: true
    },

    setStonesSkin: function(stonesSkin) {
        this.settings.stonesSkin = stonesSkin;
    },
    setBoardSkin: function(boardSkin) {
        this.settings.boardSkin = boardSkin;
    },
    setHighlight: function(highlight) {
        this.settings.highlight = highlight;
    },
    setMusic: function(music) {
        this.settings.music = music;
    },
    setSounds: function(sounds) {
        this.settings.sounds = sounds;
    },

    ai: {
        level: 0
    },

    //--------------------------------------------------------------------

    /*
     * All resources for game.
     */
    resourcesBig: {
        "image": [
            ["background", "assets/images/700x1440/images/background.png"],
            ["game_bg", "assets/images/700x1440/images/game_bg.png"],
            ["overlay", "assets/images/700x1440/images/overlay.png"],
            ["bg_square_off", "assets/images/700x1440/images/bg_square_off.png"],
            ["bg_square_on", "assets/images/700x1440/images/bg_square_on.png"],
            ["board1_n", "assets/images/700x1440/images/board1_n.png"],
            ["board1", "assets/images/700x1440/images/board1.png"],
            ["board2_n", "assets/images/700x1440/images/board2_n.png"],
            ["board2", "assets/images/700x1440/images/board2.png"],
            ["board3_n", "assets/images/700x1440/images/board3_n.png"],
            ["board3", "assets/images/700x1440/images/board3.png"],
            ["board4_n", "assets/images/700x1440/images/board4_n.png"],
            ["board4", "assets/images/700x1440/images/board4.png"],
            ["board5_n", "assets/images/700x1440/images/board5_n.png"],
            ["board5", "assets/images/700x1440/images/board5.png"],
            ["bt_arrow_l", "assets/images/700x1440/images/bt_arrow_l.png"],
            ["bt_arrow_r", "assets/images/700x1440/images/bt_arrow_r.png"],
            ["bt_back", "assets/images/700x1440/images/bt_back.png"],
            ["bt_ingame_menu", "assets/images/700x1440/images/bt_ingame_menu.png"],
            ["bt_instruction_off", "assets/images/700x1440/images/bt_instruction_off.png"],
            ["bt_instruction_on", "assets/images/700x1440/images/bt_instruction_on.png"],
            ["bt_menu", "assets/images/700x1440/images/bt_menu.png"],
            ["bt_menu2", "assets/images/700x1440/images/bt_menu2.png"],
            ["bt_restart", "assets/images/700x1440/images/bt_restart.png"],
            ["bt_restart2", "assets/images/700x1440/images/bt_restart2.png"],
            ["bt_setting", "assets/images/700x1440/images/bt_setting.png"],
            ["bt_short_off", "assets/images/700x1440/images/bt_short_off.png"],
            ["bt_short_on", "assets/images/700x1440/images/bt_short_on.png"],
            ["bt_shutdown", "assets/images/700x1440/images/bt_shutdown.png"],
            ["bt_undo", "assets/images/700x1440/images/bt_undo.png"],
            ["bt_undo2", "assets/images/700x1440/images/bt_undo2.png"],

            ["hand", "assets/images/700x1440/images/hand.png"],
            ["on_off1", "assets/images/700x1440/images/on_off1.png"],
            ["on_off2", "assets/images/700x1440/images/on_off2.png"],
            ["PLAY_bt", "assets/images/700x1440/images/PLAY_bt.png"],
            ["PLAY_new", "assets/images/700x1440/images/PLAY_new.png"],
            ["players_icon", "assets/images/700x1440/images/players_icon.png"],
            ["splash", "assets/images/700x1440/images/splash.png"],
            ["X-ko", "assets/images/700x1440/images/X-ko.png"],
            ["language_bg_full", "assets/images/700x1440/images/language_bg.png"],
            ["st1", "assets/images/700x1440/images/st1.png"],
            ["st2", "assets/images/700x1440/images/st2.png"],
            ["st3", "assets/images/700x1440/images/st3.png"],
            ["st4", "assets/images/700x1440/images/st4.png"],
            ["st5", "assets/images/700x1440/images/st5.png"],
            ["stone1a", "assets/images/700x1440/images/stone1a.png"],
            ["stone1b", "assets/images/700x1440/images/stone1b.png"],
            ["stone2a", "assets/images/700x1440/images/stone2a.png"],
            ["stone2b", "assets/images/700x1440/images/stone2b.png"],
            ["stone3a", "assets/images/700x1440/images/stone3a.png"],
            ["stone3b", "assets/images/700x1440/images/stone3b.png"],
            ["stone4a", "assets/images/700x1440/images/stone4a.png"],
            ["stone4b", "assets/images/700x1440/images/stone4b.png"],
            ["stone5a", "assets/images/700x1440/images/stone5a.png"],
            ["stone5b", "assets/images/700x1440/images/stone5b.png"],
            ["LOSE", "assets/images/700x1440/images/LOSE.png"],
            ["WIN", "assets/images/700x1440/images/WIN.png"],
            ["white", "assets/images/700x1440/images/white.png"],

            ["DRAW", "assets/images/700x1440/images/DRAW.png"],
            ["DRAW2", "assets/images/700x1440/images/DRAW2.png"],
            ["eclipse", "assets/images/700x1440/images/eclipse.png"],
            ["shine", "assets/images/700x1440/images/shine.png"],

            ["flag1", "assets/images/700x1440/images/flag1.png"],
            ["flag2", "assets/images/700x1440/images/flag2.png"],
            ["flag3", "assets/images/700x1440/images/flag3.png"],
            ["flag4", "assets/images/700x1440/images/flag4.png"],
            ["flag5", "assets/images/700x1440/images/flag5.png"],
            ["flag6", "assets/images/700x1440/images/flag6.png"],

            ["result_bg", "assets/images/700x1440/images/result_components/bg.png"],
            ["result_blue", "assets/images/700x1440/images/result_components/blue.png"],
            ["result_draw", "assets/images/700x1440/images/result_components/draw.png"],
            ["result_green", "assets/images/700x1440/images/result_components/green.png"],
            ["result_lose", "assets/images/700x1440/images/result_components/lose.png"],
            ["result_red", "assets/images/700x1440/images/result_components/red.png"],
            ["result_win", "assets/images/700x1440/images/result_components/win.png"]

        ],
        'spritesheet': [
            //width, heigth
            ["dialog_bg", "assets/images/700x1440/images/dialog_bg.png", 620, 69],
            ["language_bg", "assets/images/700x1440/images/language_bg.png", 42, 126],
            ["icons", "assets/images/700x1440/sprites/icons.png", 37, 37],
            ["selector", "assets/images/700x1440/sprites/selector.png", 74, 74],
            ["stone1", "assets/images/700x1440/sprites/stone1.png", 74, 74],
            ["stone2", "assets/images/700x1440/sprites/stone2.png", 74, 74],
            ["stone3", "assets/images/700x1440/sprites/stone3.png", 74, 74],
            ["stone4", "assets/images/700x1440/sprites/stone4.png", 74, 74],
            ["stone5", "assets/images/700x1440/sprites/stone5.png", 74, 74],
            // ["language", "assets/images/700x1440/sprites/language.png", 90, 90],
            ["language", "assets/images/700x1440/sprites/langs.png", 90, 0]

        ]
    },



    resourcesSmall: {
        "image": [
            ["background", "assets/images/480x800/images/background.png"],
            ["game_bg", "assets/images/480x800/images/game_bg.png"],
            ["overlay", "assets/images/480x800/images/overlay.png"],
            ["bg_square_off", "assets/images/480x800/images/bg_square_off.png"],
            ["bg_square_on", "assets/images/480x800/images/bg_square_on.png"],
            ["board1_n", "assets/images/480x800/images/board1_n.png"],
            ["board1", "assets/images/480x800/images/board1.png"],
            ["board2_n", "assets/images/480x800/images/board2_n.png"],
            ["board2", "assets/images/480x800/images/board2.png"],
            ["board3_n", "assets/images/480x800/images/board3_n.png"],
            ["board3", "assets/images/480x800/images/board3.png"],
            ["board4_n", "assets/images/480x800/images/board4_n.png"],
            ["board4", "assets/images/480x800/images/board4.png"],
            ["board5_n", "assets/images/480x800/images/board5_n.png"],
            ["board5", "assets/images/480x800/images/board5.png"],
            ["bt_arrow_l", "assets/images/480x800/images/bt_arrow_l.png"],
            ["bt_arrow_r", "assets/images/480x800/images/bt_arrow_r.png"],
            ["bt_back", "assets/images/480x800/images/bt_back.png"],
            ["bt_ingame_menu", "assets/images/480x800/images/bt_ingame_menu.png"],
            ["bt_instruction_off", "assets/images/480x800/images/bt_instruction_off.png"],
            ["bt_instruction_on", "assets/images/480x800/images/bt_instruction_on.png"],
            ["bt_menu", "assets/images/480x800/images/bt_menu.png"],
            ["bt_menu2", "assets/images/480x800/images/bt_menu2.png"],
            ["bt_restart", "assets/images/480x800/images/bt_restart.png"],
            ["bt_restart2", "assets/images/480x800/images/bt_restart2.png"],
            ["bt_setting", "assets/images/480x800/images/bt_setting.png"],
            ["bt_short_off", "assets/images/480x800/images/bt_short_off.png"],
            ["bt_short_on", "assets/images/480x800/images/bt_short_on.png"],
            ["bt_shutdown", "assets/images/480x800/images/bt_shutdown.png"],
            ["bt_undo", "assets/images/480x800/images/bt_undo.png"],
            ["bt_undo2", "assets/images/480x800/images/bt_undo2.png"],

            ["hand", "assets/images/480x800/images/hand.png"],
            ["on_off1", "assets/images/480x800/images/on_off1.png"],
            ["on_off2", "assets/images/480x800/images/on_off2.png"],
            ["PLAY_bt", "assets/images/480x800/images/PLAY_bt.png"],
            ["PLAY_new", "assets/images/480x800/images/PLAY_new.png"],
            ["players_icon", "assets/images/480x800/images/players_icon.png"],
            ["splash", "assets/images/480x800/images/splash.png"],
            ["X-ko", "assets/images/480x800/images/X-ko.png"],
            ["language_bg_full", "assets/images/480x800/images/language_bg.png"],
            ["st1", "assets/images/480x800/images/st1.png"],
            ["st2", "assets/images/480x800/images/st2.png"],
            ["st3", "assets/images/480x800/images/st3.png"],
            ["st4", "assets/images/480x800/images/st4.png"],
            ["st5", "assets/images/480x800/images/st5.png"],
            ["stone1a", "assets/images/480x800/images/stone1a.png"],
            ["stone1b", "assets/images/480x800/images/stone1b.png"],
            ["stone2a", "assets/images/480x800/images/stone2a.png"],
            ["stone2b", "assets/images/480x800/images/stone2b.png"],
            ["stone3a", "assets/images/480x800/images/stone3a.png"],
            ["stone3b", "assets/images/480x800/images/stone3b.png"],
            ["stone4a", "assets/images/480x800/images/stone4a.png"],
            ["stone4b", "assets/images/480x800/images/stone4b.png"],
            ["stone5a", "assets/images/480x800/images/stone5a.png"],
            ["stone5b", "assets/images/480x800/images/stone5b.png"],
            ["LOSE", "assets/images/480x800/images/LOSE.png"],
            ["WIN", "assets/images/480x800/images/WIN.png"],
            ["white", "assets/images/480x800/images/white.png"],

            ["DRAW", "assets/images/480x800/images/DRAW.png"],
            ["DRAW2", "assets/images/480x800/images/DRAW2.png"],
            ["eclipse", "assets/images/480x800/images/eclipse.png"],
            ["shine", "assets/images/480x800/images/shine.png"],

            ["flag1", "assets/images/480x800/images/flag1.png"],
            ["flag2", "assets/images/480x800/images/flag2.png"],
            ["flag3", "assets/images/480x800/images/flag3.png"],
            ["flag4", "assets/images/480x800/images/flag4.png"],
            ["flag5", "assets/images/480x800/images/flag5.png"],
            ["flag6", "assets/images/480x800/images/flag6.png"]
        ],
        'spritesheet': [
            //width, heigth
            ["dialog_bg", "assets/images/480x800/images/dialog_bg.png", 433, 50],
            ["language_bg", "assets/images/480x800/images/language_bg.png", 30, 90],
            ["icons", "assets/images/480x800/sprites/icons.png", 25, 25],
            ["selector", "assets/images/480x800/sprites/selector.png", 51, 51],
            ["stone1", "assets/images/480x800/sprites/stone1.png", 51, 51],
            ["stone2", "assets/images/480x800/sprites/stone2.png", 51, 51],
            ["stone3", "assets/images/480x800/sprites/stone3.png", 51, 51],
            ["stone4", "assets/images/480x800/sprites/stone4.png", 51, 51],
            ["stone5", "assets/images/480x800/sprites/stone5.png", 51, 51],
            // ["language", "assets/images/480x800/sprites/language.png", 60, 60],
            ["language", "assets/images/480x800/sprites/langs.png", 60, 0]
        ]

    },


    audio: {
        // Path without extension.
        hudba_menu: {
            path: "assets/audio/hudba_menu",
            volume: 1,
            loop: true,
            type: "audio"
        },
        hudba2: {
            path: "assets/audio/hudba2",
            volume: 1,
            loop: true,
            type: "music"
        },
        jingle_dama: {
            path: "assets/audio/jingle dama",
            volume: 1,
            loop: false,
            type: "audio"
        },
        click: {
            path: "assets/audio/click",
            volume: 1,
            loop: false,
            type: "audio"
        },
        figurina_tapnutie: {
            path: "assets/audio/figurina_tapnutie",
            volume: 1,
            loop: false,
            type: "audio"
        },
        menu_swoosh: {
            path: "assets/audio/menu_swoosh ",
            volume: 1,
            loop: false,
            type: "audio"
        },
        odkotulanie: {
            path: "assets/audio/odkotulanie",
            volume: 1,
            loop: false,
            type: "audio"
        },
        response_negative: {
            path: "assets/audio/response_negative",
            volume: 1,
            loop: false,
            type: "audio"
        },
        result_lose: {
            path: "assets/audio/result_lose",
            volume: 1,
            loop: false,
            type: "audio"
        },
        result_neutral: {
            path: "assets/audio/result_neutral",
            volume: 1,
            loop: false,
            type: "audio"
        },
        result_win: {
            path: "assets/audio/result_win",
            volume: 1,
            loop: false,
            type: "audio"
        },
        suchnutie1: {
            path: "assets/audio/suchnutie1",
            volume: 1,
            loop: false,
            type: "audio"
        },
        suchnutie2: {
            path: "assets/audio/suchnutie2",
            volume: 1,
            loop: false,
            type: "audio"
        }
    },

    /*
     * Set addapting background. Done by Jakub Smekal.
     */
    addBackground: function(key) {
        var bg = this.phaser.add.image(this.phaser.world.centerX, this.phaser.world.centerY, key);
        bg.anchor.setTo(0.5);

        var diff = Math.max(this.phaser.width - bg.width, this.phaser.height - bg.height);

        if (diff > 0) {
            bg.width += diff;
            bg.height += diff;
        }
    },


    /*
     * Get board sprite.
     */
    getBoardSprite: function() {
        if (this.settings.boardSkin == 0) {
            return "board1";
        } else if (this.settings.boardSkin == 1) {
            return "board2";
        } else if (this.settings.boardSkin == 2) {
            return "board3";
        } else if (this.settings.boardSkin == 3) {
            return "board4";
        } else if (this.settings.boardSkin == 4) {
            return "board5";
        }
    },


    /*
     * Get stone sprites.
     */
    getStonesSprites: function() {
        if (this.settings.stonesSkin == 0) {
            return "stone1";
        } else if (this.settings.stonesSkin == 1) {
            return "stone2";
        } else if (this.settings.stonesSkin == 2) {
            return "stone3";
        } else if (this.settings.stonesSkin == 3) {
            return "stone4";
        } else if (this.settings.stonesSkin == 4) {
            return "stone5";
        }
    },


    /*
     * Get stone sprites to setting to setting switchers.
     */
    getStonesSpritesToSettings: function() {
        if (this.settings.stonesSkin == 0) {
            return ["st1", "stone1a", "stone1b"];
        } else if (this.settings.stonesSkin == 1) {
            return ["st2", "stone2a", "stone2b"];
        } else if (this.settings.stonesSkin == 2) {
            return ["st3", "stone3a", "stone3b"];
        } else if (this.settings.stonesSkin == 3) {
            return ["st4", "stone4a", "stone4b"];
        } else if (this.settings.stonesSkin == 4) {
            return ["st5", "stone5a", "stone5b"];
        }
    },

    //--------------------------------------------------------------------

    getRndInteger: function(min, max) {
        return Math.floor(Math.random() * (max - min + 1)) + min;
    },

    getRndIntegerBubles: function(min, max, exceptMin, exceptMax) {
        var number = Math.floor(Math.random() * (max - min + 1)) + min;

        if (number < exceptMax && number > exceptMin) {
            this.getRndIntegerBubles(min, max, exceptMin, exceptMax)
        }

        return number;
    },

    calculateDialogSize: function calculateDialogSize(spaceTop, spaceBoottom, oneTileSize) {
        var i = 0;
        var possitions = [];
        possitions[0] = spaceTop + 50;
        while (1) {
            possitions[i] = spaceTop + (i * oneTileSize)
            if (possitions[i] > (spaceBoottom - 100)) {
                break;
            }
            i++;
        }

        return possitions;
    },

    calculatePositions: function calculatePositions(spaceTop, spaceBoottom, buttonSize, buttonCount) {
        var totalHeight = spaceBoottom - spaceTop;
        var spaceSize = totalHeight / (buttonCount + 1);

        var possitions = [];
        for (var i = 0; i < buttonCount; i++) {
            possitions[i] = spaceTop + (spaceSize * (i)) + (spaceSize / 1.5) + (buttonSize / 2);
        }

        return possitions
    },

    isInt: function isInt(n) {
        return Number(n) === n && n % 1 === 0;
    },

    isFloat: function isFloat(n) {
        return Number(n) === n && n % 1 !== 0;
    },


    getDiagonal: function getDiagonal(from, to) {
        var posFrom = this.getRowAndColFromGraph(from);
        var posTo = this.getRowAndColFromGraph(to);
        for (var i = 0; i < 7; i++) {
            if (posFrom[0] + i < 8 && posFrom[1] + i < 8) {
                if (this.boardForGraph[posFrom[0] + i][posFrom[1] + i] == this.boardForGraph[posTo[0]][posTo[1]]) {
                    return "1"
                }
            }

            if (posFrom[0] - i >= 0 && posFrom[1] - i >= 0) {
                if (this.boardForGraph[posFrom[0] - i][posFrom[1] - i] == this.boardForGraph[posTo[0]][posTo[1]]) {
                    return "1"
                }
            }

            if (posFrom[0] - i >= 0 && posFrom[1] + i < 8) {
                if (this.boardForGraph[posFrom[0] - i][posFrom[1] + i] == this.boardForGraph[posTo[0]][posTo[1]]) {
                    return "2"
                }
            }

            if (posFrom[0] + i < 8 && posFrom[1] - i >= 0) {
                if (this.boardForGraph[posFrom[0] + i][posFrom[1] - i] == this.boardForGraph[posTo[0]][posTo[1]]) {
                    return "2"
                }
            }
        }
        return null;
    },


    isSingle: function isSingle(move) {
        var moves = move.split("->");

        var pos1 = this.getRowAndColFromGraph(moves[0]);

        if (pos1[0] + 1 < 8 && pos1[1] + 1 < 8) {
            if (this.boardForGraph[pos1[0] + 1][pos1[1] + 1] == moves[1]) {
                return true;
            }
        }

        if (pos1[0] - 1 >= 0 && pos1[1] - 1 >= 0) {
            if (this.boardForGraph[pos1[0] - 1][pos1[1] - 1] == moves[1]) {
                return true;
            }
        }

        if (pos1[0] + 1 < 8 && pos1[1] - 1 >= 0) {
            if (this.boardForGraph[pos1[0] + 1][pos1[1] - 1] == moves[1]) {
                return true;
            }
        }

        if (pos1[0] - 1 >= 8 && pos1[1] + 1 < 8) {
            if (this.boardForGraph[pos1[0] - 1][pos1[1] + 1] == moves[1]) {
                return true;
            }
        }

        return false;
    },

    canBeOverjumped: function canBeOverjumped(move, board, player, origin, splited) {
        var pos1 = move;

        if (splited.length > 2) {
            if (pos1[0] + 1 < 8 && pos1[1] + 1 < 8 && pos1[0] - 1 >= 0 && pos1[1] - 1 >= 0) {
                if (board[pos1[0] + 1][pos1[1] + 1] == null && board[pos1[0] - 1][pos1[1] - 1] != null) {
                    if (board[pos1[0] - 1][pos1[1] - 1].getPlayer() != player) {
                        return true;
                    }
                }
                if (board[pos1[0] + 1][pos1[1] + 1] != null && board[pos1[0] - 1][pos1[1] - 1] == null) {
                    if (board[pos1[0] + 1][pos1[1] + 1].getPlayer() != player) {
                        return true;
                    }
                }
            }

            if (pos1[0] + 1 < 8 && pos1[1] - 1 >= 0 && pos1[0] - 1 >= 0 && pos1[1] + 1 < 8) {
                if (board[pos1[0] + 1][pos1[1] - 1] == null && board[pos1[0] - 1][pos1[1] + 1] != null) {
                    if (board[pos1[0] - 1][pos1[1] + 1].getPlayer() != player) {
                        return true;
                    }
                }
                if (board[pos1[0] + 1][pos1[1] - 1] != null && board[pos1[0] - 1][pos1[1] + 1] == null) {
                    if (board[pos1[0] + 1][pos1[1] - 1].getPlayer() != player) {
                        return true;
                    }
                }
            }
        } else {
            if (this.getDiagonal(this.boardForGraph[origin[0]][origin[1]], this.boardForGraph[move[0]][move[1]]) == "1") {
                if (pos1[0] + 1 < 8 && pos1[1] + 1 < 8 && pos1[0] - 1 >= 0 && pos1[1] - 1 >= 0) {
                    if (board[pos1[0] + 1][pos1[1] + 1] != null && board[pos1[0] - 1][pos1[1] - 1] != null) {
                        if (board[pos1[0] - 1][pos1[1] - 1].getPlayer() != player && board[pos1[0] - 1][pos1[1] - 1].getPlayer() == board[pos1[0] + 1][pos1[1] + 1].getPlayer()) {
                            return true;
                        }
                    }
                    if (board[pos1[0] + 1][pos1[1] + 1] != null && board[pos1[0] - 1][pos1[1] - 1] != null) {
                        if (board[pos1[0] + 1][pos1[1] + 1].getPlayer() != player && board[pos1[0] - 1][pos1[1] - 1].getPlayer() == board[pos1[0] + 1][pos1[1] + 1].getPlayer()) {
                            return true;
                        }
                    }
                }
            }

            if (this.getDiagonal(this.boardForGraph[origin[0]][origin[1]], this.boardForGraph[move[0]][move[1]]) == "2") {
                if (pos1[0] + 1 < 8 && pos1[1] - 1 >= 0 && pos1[0] - 1 >= 0 && pos1[1] + 1 < 8) {
                    if (board[pos1[0] + 1][pos1[1] - 1] != null && board[pos1[0] - 1][pos1[1] + 1] != null) {
                        if (board[pos1[0] - 1][pos1[1] + 1].getPlayer() != player && board[pos1[0] - 1][pos1[1] + 1].getPlayer() == board[pos1[0] + 1][pos1[1] - 1].getPlayer()) {
                            return true;
                        }
                    }
                    if (board[pos1[0] + 1][pos1[1] - 1] != null && board[pos1[0] - 1][pos1[1] + 1] != null) {
                        if (board[pos1[0] + 1][pos1[1] - 1].getPlayer() != player && board[pos1[0] - 1][pos1[1] + 1].getPlayer() == board[pos1[0] + 1][pos1[1] - 1].getPlayer()) {
                            return true;
                        }
                    }
                }
            }
        }


        // checking for king
        for (var i = 1; i < 8; i++) {
            if (pos1[0] + i < 8 && pos1[1] + i < 8 && pos1[0] - i >= 0 && pos1[1] - i >= 0) {

                if (board[pos1[0] + 1][pos1[1] + 1] == null && board[pos1[0] - i][pos1[1] - i] != null) {
                    if (board[pos1[0] - i][pos1[1] - i].getPlayer() != player && board[pos1[0] - i][pos1[1] - i].whatAmI() == "king") {
                        return true;
                    }
                }
                if (board[pos1[0] + i][pos1[1] + i] != null && board[pos1[0] - 1][pos1[1] - 1] == null) {
                    if (board[pos1[0] + i][pos1[1] + i].getPlayer() != player && board[pos1[0] + i][pos1[1] + i].whatAmI() == "king") {
                        return true;
                    }
                }
            }
        }

        for (var i = 1; i < 8; i++) {
            if (pos1[0] + i < 8 && pos1[1] - i >= 0 && pos1[0] - i >= 0 && pos1[1] + i < 8) {

                if (board[pos1[0] - 1][pos1[1] + 1] == null && board[pos1[0] + i][pos1[1] - i] != null) {
                    if (board[pos1[0] + i][pos1[1] - i].getPlayer() != player && board[pos1[0] + i][pos1[1] - i].whatAmI() == "king") {
                        return true;
                    }
                }
                if (board[pos1[0] - i][pos1[1] + i] != null && board[pos1[0] + 1][pos1[1] - 1] == null) {
                    if (board[pos1[0] - i][pos1[1] + i].getPlayer() != player && board[pos1[0] - i][pos1[1] + i].whatAmI() == "king") {
                        return true;
                    }
                }
            }
        }


        return false;
    },


    canBeOverjumpedByKing: function canBeOverjumpedByKing(move, board, player) {
        var pos1 = move;

        for (var i = 1; i < 8; i++) {
            if (pos1[0] + i < 8 && pos1[1] + i < 8 && pos1[0] - i >= 0 && pos1[1] - i >= 0) {

                if (board[pos1[0] + 1][pos1[1] + 1] == null && board[pos1[0] - i][pos1[1] - i] != null) {
                    if (board[pos1[0] - i][pos1[1] - i].getPlayer() != player && board[pos1[0] - i][pos1[1] - i].whatAmI() == "king") {
                        return true;
                    }
                }
                if (board[pos1[0] + i][pos1[1] + i] != null && board[pos1[0] - 1][pos1[1] - 1] == null) {
                    if (board[pos1[0] + i][pos1[1] + i].getPlayer() != player && board[pos1[0] + i][pos1[1] + i].whatAmI() == "king") {
                        return true;
                    }
                }
            }
        }

        for (var i = 1; i < 8; i++) {
            if (pos1[0] + i < 8 && pos1[1] - i >= 0 && pos1[0] - i >= 0 && pos1[1] + i < 8) {

                if (board[pos1[0] - 1][pos1[1] + 1] == null && board[pos1[0] + i][pos1[1] - i] != null) {
                    if (board[pos1[0] + i][pos1[1] - i].getPlayer() != player && board[pos1[0] + i][pos1[1] - i].whatAmI() == "king") {
                        return true;
                    }
                }
                if (board[pos1[0] - i][pos1[1] + i] != null && board[pos1[0] + 1][pos1[1] - 1] == null) {
                    if (board[pos1[0] - i][pos1[1] + i].getPlayer() != player && board[pos1[0] - i][pos1[1] + i].whatAmI() == "king") {
                        return true;
                    }
                }
            }
        }

        return false;
    }
};