"use strict";

var GameHistory = function() {
    if (global.storage.data.historyMoves == null) {
        this.historyMoves = [];
    } else {
        this.historyMoves = global.storage.data.historyMoves;
    }

    if (global.storage.data.removedCheckers == null) {
        this.removedCheckers = [];
    } else {
        this.removedCheckers = global.storage.data.removedCheckers;
    }

    if (global.storage.data.historyBoardOfValues == null) {
        this.historyBoardOfValues = [];
    } else {
        this.historyBoardOfValues = global.storage.data.historyBoardOfValues;
    }

};

GameHistory.prototype = {

    addBoard: function(board, data) {
        this.historyMoves.push(board);
        this.historyBoardOfValues.push(data.map(function(arr) {
            return arr.slice();
        }));
    },

    addRemoved: function(checkers) {
        this.removedCheckers.push(checkers);
    },

    getRemoved: function() {
        return this.removedCheckers.pop();
    },

    getMoves: function() {
        return this.historyMoves.pop();
    },

    getBoardValues: function() {
        return this.historyBoardOfValues.pop();
    },

    getHistorySize: function() {
        return this.historyBoardOfValues.length;
    },



    getFullMoves: function() {
        return this.historyMoves;
    },

    getFullCheckers: function() {
        return this.removedCheckers;
    },

    getFullValues: function() {
        return this.historyBoardOfValues;
    },



    setFullMoves: function(a) {
        this.historyMoves = a;
    },

    setFullCheckers: function(a) {
        this.removedCheckers = a;
    },

    setFullValues: function(a) {
        this.historyBoardOfValues = a;
    },

};