"use strict";

var PlayerBot = function PlayerBot(game, board, playersCheckers, player, aiLevel) {
    this.game = game;
    this.boardObj = board;
    this.imageKey = playersCheckers;
    this.playersCheckers = playersCheckers;
    this.player = player;
    this.aiLevel = aiLevel;
};

PlayerBot.prototype = {

    makeMove: function makeMove() {
        var _this = this;

        this.boardObj.stopAllPulsingCheckers();

        this.boardObj.changeCurrentPlayer();

        global.createTimer(global.times.TOP_CHECKERS_TWEEN_TIME * 3, function () {
            if (_this.aiLevel == 1) {
                _this.makeMoveHard();
            } else if (_this.aiLevel == 2) {
                _this.makeMoveMedium();
            } else if (_this.aiLevel == 3) {
                _this.makeMoveEasy();
            }
        });
    },

    makeMoveHard: function makeMoveHard() {
        console.log("----------------NEW BOT MOVE-----------------------");

        //get all moves
        var possibleMoves = this.boardObj.showPossibleCheckersOnBoard(1);
        console.log(possibleMoves);
        
        if(possibleMoves == undefined){
            return;
        }

        var checkerMoveOptions = [];
        for (var i = 0; i < possibleMoves.length; i++) {
            possibleMoves[i].onTouchBot(1);
            checkerMoveOptions[i] = this.boardObj.getPaths();
        }
        console.log(checkerMoveOptions);


        //create array
        var jumpMoves = [],
            cols = 10;
        for (var i = 0; i < cols; i++) {
            jumpMoves[i] = [];
        }

        //todo: its possible that storing only king moves
        //-------------------NORMAL JUMP------------------
        for (var i = 0; i < checkerMoveOptions.length; i++) {
            for (var j = 0; j < checkerMoveOptions[i].length; j++) {
                if (!global.isSingle(checkerMoveOptions[i][j]) && checkerMoveOptions[i][j].length > 2) {
                    var splited = checkerMoveOptions[i][j].split("->");
                    jumpMoves[splited.length].push(checkerMoveOptions[i][j]);
                }
            }
        }

        console.log("jumpMoves");
        console.log(jumpMoves);
        for (var q = 9; q >= 0; q--) {
            if (jumpMoves[q].length != 0) {

                //check end position
                var moveToJump = -1;
                for(var w = 0; w<jumpMoves[q].length; w++){
                    console.log(jumpMoves[q][w]);
                    
                    var splited = jumpMoves[q][w].split("->");
                    var posOrigin = global.getRowAndColFromGraph(splited[0]);
                    var pos = global.getRowAndColFromGraph(splited[splited.length-1]);
                    var origin = global.getRowAndColFromGraph(splited[0]);

                    if(!global.canBeOverjumped(pos, this.boardObj.getGameBoardCheckers(), this.boardObj.getGameBoardCheckers()[posOrigin[0]][posOrigin[1]].getPlayer(), origin, splited)
                         && !global.canBeOverjumpedByKing(pos, this.boardObj.getGameBoardCheckers(), this.boardObj.getGameBoardCheckers()[posOrigin[0]][posOrigin[1]].getPlayer())){
                            moveToJump = w;
                            break;                        
                    }
                }

                if(moveToJump == -1){
                    var rand = global.getRndInteger(0, jumpMoves[q].length - 1);
                    var finalPositions = this.regexFind(jumpMoves[q][rand], true);
                }else{
                    var finalPositions = this.regexFind(jumpMoves[q][moveToJump], true);
                }

                console.log("-------------");
                console.log(finalPositions);
                console.log(finalPositions[0]);
                console.log(finalPositions[finalPositions.length-1]);
                
                var finalPositionsFrom = global.getRowAndColFromGraph(finalPositions[0]);
                var finalPositionsTo = global.getRowAndColFromGraph(finalPositions[finalPositions.length-1]);

                var possibleMoves = this.boardObj.showPossibleCheckersOnBoard(1);

                this.boardObj.getGameBoardCheckers()[finalPositionsFrom[0]][finalPositionsFrom[1]].onTouchBot(1);
                this.boardObj.moveToBot(finalPositionsTo[0], finalPositionsTo[1]);
                return;
            }
        }


        //-------------------NORMAL MOVE------------------
        //create array
        var reducedMoves = [],
            cols = checkerMoveOptions.length;
        for (var i = 0; i < cols; i++) {
            reducedMoves[i] = [];
        }

        //bet all simple moves
        for (var i = 0; i < checkerMoveOptions.length; i++) {
            for (var j = 0; j < checkerMoveOptions[i].length; j++) {
                var splited = checkerMoveOptions[i][j] + "";
                if (splited.split("->").length == 2) {
                    if (global.isSingle(checkerMoveOptions[i][j])) {
                        reducedMoves[i].push(checkerMoveOptions[i][j]);
                    }
                }
            }
        }
        console.log(reducedMoves);

        //create array
        var movesToDo = [],
            cols = 10;
        for (var i = 0; i < cols; i++) {
            movesToDo[i] = [];
        }

        for (var i = 0; i < reducedMoves.length; i++) {
            for (var j = 0; j < reducedMoves[i].length; j++) {
                var pos = reducedMoves[i][j].split("->");
                this.boardObj.moveToFake(pos[0], pos[1]);
                var opponentDest = this.getOpponentDestinations(true);

                if(opponentDest == undefined) return;

                console.log(opponentDest);

                if (opponentDest.length != 0) {
                    console.log(opponentDest.length);

                    for (var x = 0; x < opponentDest.length; x++) {
                        movesToDo[opponentDest[x].split("->").length].push(reducedMoves[i][j]);
                    }

                } else {
                    movesToDo[0].push(reducedMoves[i][j]);
                }

                this.boardObj.moveToFakeReverse(pos[0], pos[1]);
            }
        }

        console.log(reducedMoves);
        console.log(movesToDo);

        //---------- DO ACTUAL MOVE ----------
        for (var q = 0; q < 9; q++) {
            if (movesToDo[q].length != 0) {
                var rand = global.getRndInteger(0, movesToDo[q].length - 1);

                var finalPositions = this.regexFind(movesToDo[q][rand], true);
                var finalPositionsFrom = global.getRowAndColFromGraph(finalPositions[0]);
                var finalPositionsTo = global.getRowAndColFromGraph(finalPositions[1]);

                var possibleMoves = this.boardObj.showPossibleCheckersOnBoard(1);

                this.boardObj.getGameBoardCheckers()[finalPositionsFrom[0]][finalPositionsFrom[1]].onTouchBot(1);
                this.boardObj.moveToBot(finalPositionsTo[0], finalPositionsTo[1]);
                break;
            }
        }

        this.boardObj.cleanShowPossibleMovesOnBoardArray();
    },

    makeMoveMedium: function makeMoveMedium() {
        console.log("----------------NEW BOT MOVE-----------------------");

        //get all moves
        var possibleMoves = this.boardObj.showPossibleCheckersOnBoard(1);
        if(possibleMoves == undefined){
            return;
        }

        var checkerMoveOptions = [];
        for (var i = 0; i < possibleMoves.length; i++) {
            possibleMoves[i].onTouchBot(1);
            checkerMoveOptions[i] = this.boardObj.getPaths();
        }
        console.log(checkerMoveOptions);


        //create array
        var jumpMoves = [],
            cols = 10;
        for (var i = 0; i < cols; i++) {
            jumpMoves[i] = [];
        }

        //-------------------NORMAL JUMP------------------
        for (var i = 0; i < checkerMoveOptions.length; i++) {
            for (var j = 0; j < checkerMoveOptions[i].length; j++) {
                if (!global.isSingle(checkerMoveOptions[i][j]) && checkerMoveOptions[i][j].length > 2) {
                    var splited = checkerMoveOptions[i][j].split("->");
                    jumpMoves[splited.length].push(checkerMoveOptions[i][j]);
                }
            }
        }

        console.log("jumpMoves");
        console.log(jumpMoves);
        for (var q = 9; q >= 0; q--) {
            if (jumpMoves[q].length != 0) {
                var rand = global.getRndInteger(0, jumpMoves[q].length - 1);

                var finalPositions = this.regexFind(jumpMoves[q][rand], true);
                console.log("-------------");
                console.log(finalPositions);
                console.log(finalPositions[0]);
                console.log(finalPositions[finalPositions.length-1]);
                
                var finalPositionsFrom = global.getRowAndColFromGraph(finalPositions[0]);
                var finalPositionsTo = global.getRowAndColFromGraph(finalPositions[finalPositions.length-1]);

                var possibleMoves = this.boardObj.showPossibleCheckersOnBoard(1);

                this.boardObj.getGameBoardCheckers()[finalPositionsFrom[0]][finalPositionsFrom[1]].onTouchBot(1);
                this.boardObj.moveToBot(finalPositionsTo[0], finalPositionsTo[1]);
                return;
            }
        }


        //-------------------NORMAL MOVE------------------
        //create array
        var reducedMoves = [],
            cols = checkerMoveOptions.length;
        for (var i = 0; i < cols; i++) {
            reducedMoves[i] = [];
        }

        //bet all simple moves
        for (var i = 0; i < checkerMoveOptions.length; i++) {
            for (var j = 0; j < checkerMoveOptions[i].length; j++) {
                var splited = checkerMoveOptions[i][j] + "";
                if (splited.split("->").length == 2) {
                    if (global.isSingle(checkerMoveOptions[i][j])) {
                        reducedMoves[i].push(checkerMoveOptions[i][j]);
                    }
                }
            }
        }
        console.log(reducedMoves);

        //create array
        var movesToDo = [],
            cols = 10;
        for (var i = 0; i < cols; i++) {
            movesToDo[i] = [];
        }

        for (var i = 0; i < reducedMoves.length; i++) {
            for (var j = 0; j < reducedMoves[i].length; j++) {
                var pos = reducedMoves[i][j].split("->");
                this.boardObj.moveToFake(pos[0], pos[1]);
                var opponentDest = this.getOpponentDestinations(true);

                if(opponentDest == undefined) return;

                console.log(opponentDest);

                if (opponentDest.length != 0) {
                    console.log(opponentDest.length);

                    for (var x = 0; x < opponentDest.length; x++) {
                        movesToDo[opponentDest[x].split("->").length].push(reducedMoves[i][j]);
                    }

                } else {
                    movesToDo[0].push(reducedMoves[i][j]);
                }

                this.boardObj.moveToFakeReverse(pos[0], pos[1]);
            }
        }

        console.log(reducedMoves);
        console.log(movesToDo);

        //---------- DO ACTUAL MOVE ----------
        for (var q = 0; q < 9; q++) {
            if (movesToDo[q].length != 0) {
                var rand = global.getRndInteger(0, movesToDo[q].length - 1);

                var finalPositions = this.regexFind(movesToDo[q][rand], true);
                var finalPositionsFrom = global.getRowAndColFromGraph(finalPositions[0]);
                var finalPositionsTo = global.getRowAndColFromGraph(finalPositions[1]);

                var possibleMoves = this.boardObj.showPossibleCheckersOnBoard(1);

                this.boardObj.getGameBoardCheckers()[finalPositionsFrom[0]][finalPositionsFrom[1]].onTouchBot(1);
                this.boardObj.moveToBot(finalPositionsTo[0], finalPositionsTo[1]);
                break;
            }
        }

        this.boardObj.cleanShowPossibleMovesOnBoardArray();
    },


    makeMoveEasy: function makeMoveEasy() {
        var captureMode = 1;

        var possibleMoves = this.boardObj.showPossibleCheckersOnBoard(captureMode);

        if(possibleMoves == undefined){
            return;
        }

        var rand = global.getRndInteger(0, possibleMoves.length - 1);
        possibleMoves[rand].onTouchBot(captureMode);

        //from base
        var paths = this.boardObj.getPaths();
        var possibleMovesConnected = [];
        for (var i = 0; i < paths.length; i++) {
            possibleMovesConnected.push(paths[i].split("->"));
        }
        var help = 0;
        var longestPath = 0;
        for (var i = 0; i < possibleMovesConnected.length; i++) {
            if (possibleMovesConnected[i].length > help) {
                help = possibleMovesConnected[i].length;
                longestPath = i;
            }
        }
        var rowcol = global.getRowAndColFromGraph(Number(possibleMovesConnected[longestPath][possibleMovesConnected[longestPath].length - 1]));
        this.boardObj.moveToBot(rowcol[0], rowcol[1]);
        this.boardObj.uncheckEveryCheckedChecker();
        this.boardObj.blockEveryChecker();
    },

    containsAny: function containsAny(str, substrings) {
        for (var i = 0; i != substrings.length; i++) {
            var substring = substrings[i];
            if (str.indexOf(substring) != -1) {
                return substring;
            }
        }
        return null;
    },

    getOpponentDestinations: function getOpponentDestinations(oponent) {
        var possibleMoves = this.boardObj.showPossibleCheckersOnBoard(1, this.boardObj.getPlayer2().getPlayer(), true);

        if (possibleMoves == undefined) {
            return;
        }

        var checkerMoveOptionsOpponent = [];
        for (var i = 0; i < possibleMoves.length; i++) {
            if (oponent) {
                possibleMoves[i].onTouchBot(1, this.boardObj.getPlayer2().getPlayer());
            } else {
                possibleMoves[i].onTouchBot(1, "current", true);
            }
            checkerMoveOptionsOpponent[i] = this.boardObj.getPaths();
        }

        var possibleDestinations = [];
        for (var out = 0; out < checkerMoveOptionsOpponent.length; out++) {
            for (var inside = 0; inside < checkerMoveOptionsOpponent[out].length; inside++) {
                if (checkerMoveOptionsOpponent[out][inside].indexOf("->") != -1) {
                    possibleDestinations.push(checkerMoveOptionsOpponent[out][inside]);
                }
            }
        }

        return possibleDestinations;
    },

    regexFind: function regexFind(input) {
        var singles = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

        var possibleDestinations = [];

        if (singles) {
            var regex = /[0-9]?[0-9]/gm;
        } else {
            var regex = /[0-9]?[0-9]->[0-9]?[0-9]$/gm;
        }
        var str = input;
        var m = void 0;
        while ((m = regex.exec(str)) !== null) {
            if (m.index === regex.lastIndex) {
                regex.lastIndex++;
            }
            m.forEach(function (match, groupIndex) {
                possibleDestinations.push(match);
            });
        }
        return possibleDestinations;
    },

    getPlayerCheckers: function getPlayerCheckers() {
        return this.playersCheckers;
    },

    getPlayer: function getPlayer() {
        return this.player;
    },

    getAiLevel: function getAiLevel() {
        return this.aiLevel;
    },

    whoAmI: function whoAmI() {
        return 'bot';
    }
};