var Tutorial = function(world, game) {
    this.world = world;
    this.game = game;
    this.hand = null;
    this.xPos= this.world.width + 100;
    this.yPos = this.world.height + 100;
};

Tutorial.prototype = {

    createHand: function create(x, y) {
        this.xPos = x;
        this.yPos = y;
        this.hand = this.game.add.sprite(this.xPos, this.yPos, 'hand');
        this.hand.anchor.setTo(0.5);   
    },

    moveHandTo: function moveHandTo(desiredX, desiredY, time) {
        var tween = this.game.add.tween(this.hand).to({
            x: desiredX,
            y: desiredY
        }, time);
        tween.start();
        tween.onComplete.add(function() {
        });
    },

    showOverlay: function(){
        global.setPauseState(true);
        var overlay = this.game.add.image(0, 0, "overlay");
        overlay.width = this.world.width;
        overlay.height = this.world.height;
        overlay.alpha = 0.65;
        overlay.inputEnabled = true;
        overlay.visible = true;
        this.overlay = overlay;
    },

    hideOverlay: function(){
        global.setPauseState(false);
        this.overlay.inputEnabled = false;
        this.overlay.visible = false;
    }, 

    getHand: function(){
        return this.hand;
    },

    destoryHand: function(){
        this.hand.destroy();
    }
};