'use strict';

var MenuState = function MenuState(game) { };

MenuState.prototype = {

    update: function update() {

        if (global.resolution == "480x800") {
            //shine in background
            this.logoBackground.angle += 0.2;
            this.logoBackground2.angle -= 0.2;

            if (this.add) {
                this.logoBackground.scale.y += 0.01;
                this.logoBackground.scale.x += 0.01;
            } else {
                this.logoBackground.scale.y -= 0.005;
                this.logoBackground.scale.x -= 0.005;
            }

            if (this.add2) {
                this.logoBackground2.scale.y += 0.015;
                this.logoBackground2.scale.x += 0.015;
            } else {
                this.logoBackground2.scale.y -= 0.01;
                this.logoBackground2.scale.x -= 0.01;
            }

            if (this.logoBackground.scale.x < 0.5) {
                this.add = true;
            } else if (this.logoBackground.scale.x > 0.9) {
                this.add = false;
            }

            if (this.logoBackground2.scale.x < 0.5) {
                this.add2 = true;
            } else if (this.logoBackground2.scale.x > 0.9) {
                this.add2 = false;
            }
        } else {
            //shine in background
            this.logoBackground.angle += 0.3;
            this.logoBackground2.angle -= 0.3;

            if (this.add) {
                this.logoBackground.scale.y += 0.02;
                this.logoBackground.scale.x += 0.02;
            } else {
                this.logoBackground.scale.y -= 0.01;
                this.logoBackground.scale.x -= 0.01;
            }

            if (this.add2) {
                this.logoBackground2.scale.y += 0.025;
                this.logoBackground2.scale.x += 0.025;
            } else {
                this.logoBackground2.scale.y -= 0.015;
                this.logoBackground2.scale.x -= 0.015;
            }

            if (this.logoBackground.scale.x < 0.8) {
                this.add = true;
            } else if (this.logoBackground.scale.x > 1.5) {
                this.add = false;
            }

            if (this.logoBackground2.scale.x < 0.8) {
                this.add2 = true;
            } else if (this.logoBackground2.scale.x > 1.5) {
                this.add2 = false;
            }
        }

        //show bubbles from behind of logo
        if (this.bubleCounter == 30) {
            var bubble = this.game.add.sprite(this.world.width / 2, this.logoBackground.height / 2 + 80, 'eclipse');
            bubble.anchor.set(0.5);
            bubble.alpha = 0.4;
            bubble.scale.x = 1.4;
            bubble.scale.y = 1.4;
            this.logoGroup.addChild(bubble);

            var randX = global.getRndIntegerBubles(-300, this.world.width + 300, 0, this.world.width);
            var randY = global.getRndIntegerBubles(-300, this.world.height / 2, 0, this.world.width);

            var tween = this.tweenTo(bubble, randX, randY, false, 10000, true);
            this.bubleCounter = 0;
            this.game.world.bringToTop(this.logo);

            tween.onComplete.add(function () {
                this.game.add.tween(bubble).to({
                    alpha: 0
                }, 1000, Phaser.Easing.Linear.None, true);
            }, this);

            this.logo.bringToTop();
        }
        this.bubleCounter++;

        if (this.buttonPlay.input.pointerOver()) {
            this.buttonPlay.tint = 0xffffff;
        } else {
            this.buttonPlay.tint = 0xdbdbdb;
        }

        if (this.buttonRules.input.pointerOver()) {
            this.buttonRules.tint = 0xffffff;
        } else {
            this.buttonRules.tint = 0xdbdbdb;
        }

        if (this.buttonSettings.input.pointerOver()) {
            this.buttonSettings.tint = 0xffffff;
        } else {
            this.buttonSettings.tint = 0xdbdbdb;
        }

        if (this.buttonAbout.input.pointerOver()) {
            this.buttonAbout.tint = 0xffffff;
        } else {
            this.buttonAbout.tint = 0xdbdbdb;
        }

        //buttons from screens
        if (this.savedGameButtons != null || this.savedGameButtons != undefined) {
            for (var i = 0; i < this.savedGameButtons.length; i++) {
                if (this.savedGameButtons[i].input.pointerOver()) {
                    this.savedGameButtons[i].tint = 0xffffff;
                } else {
                    this.savedGameButtons[i].tint = 0xdbdbdb;
                }
            }
        }

        if (this.newGameButtons != null || this.newGameButtons != undefined) {
            for (var i = 0; i < this.newGameButtons.length; i++) {
                if (this.newGameButtons[i].input.pointerOver()) {
                    this.newGameButtons[i].tint = 0xffffff;
                } else {
                    this.newGameButtons[i].tint = 0xdbdbdb;
                }
            }
        }

        if (this.exitButtons != null || this.exitButtons != undefined) {
            for (var i = 0; i < this.exitButtons.length; i++) {
                if (this.exitButtons[i].input.pointerOver()) {
                    this.exitButtons[i].tint = 0xffffff;
                } else {
                    this.exitButtons[i].tint = 0xdbdbdb;
                }
            }
        }
    },

    create: function create() {
        var _this3 = this;

        console.log("---create---");
        
        if (global.musicPlaying != true) {
            global.managers.audio.playMusic(global.managers.audio.actualMusic, true);
        }
        
        this.screenRules = undefined;
        this.screenSettings = undefined;
        this.screenInstructions = undefined;
        this.newGame = undefined;
        this.savedGame = undefined;
        this.exitScreen = undefined;

        var centerPossition = this.world.height / 2 / 2;

        var _this2 = this;
        this.bubleCounter = 29;
        global.addBackground("game_bg");

        this.screenGroup = this.game.add.group();
        this.screenGroup.name = 'Menu';

        this.logoGroup = this.game.add.group();
        this.logoBackground = this.add.sprite(this.world.width / 2, -100, 'shine');
        this.logoBackground.anchor.set(0.5);
        if (global.resolution == "480x800") {
            this.logoBackground.scale.x = 0.51;
            this.logoBackground.scale.y = 0.51;
        } else {
            this.logoBackground.scale.x = 0.81;
            this.logoBackground.scale.y = 0.81;
        }

        this.logoGroup.addChild(this.logoBackground);
        this.logoBackground2 = this.add.sprite(this.world.width / 2, -100, 'shine');
        this.logoBackground2.anchor.set(0.5);
        if (global.resolution == "480x800") {
            this.logoBackground2.scale.x = 0.9;
            this.logoBackground2.scale.y = 0.9;
        } else {
            this.logoBackground2.scale.x = 1.4;
            this.logoBackground2.scale.y = 1.4;
        }
        this.logoGroup.addChild(this.logoBackground2);

        this.logo = this.add.sprite(this.world.width / 2, -100, 'splash');
        this.logo.anchor.set(0.5);
        this.logoGroup.addChild(this.logo);

        this.tweenTo(this.logo, this.world.width / 2, centerPossition, true);
        this.tweenTo(this.logoBackground, this.world.width / 2, centerPossition, true);
        this.tweenTo(this.logoBackground2, this.world.width / 2, centerPossition, true);

        //---------------------------------------BUTTONS-------------------------------------------------------------------------
        if (global.resolution == "480x800") {
            var positions = global.calculatePositions(this.world.height / 2, this.world.height, 32, 4);
        } else {
            var positions = global.calculatePositions(this.world.height / 2, this.world.height, 48, 4);
        }

        if (global.resolution == "480x800") {
            var textStyle = {
                font: global.fonts.small,
                fill: "#FFFFFF",
                align: "center"
            };
            var textStylePlay = {
                font: global.fonts.small,
                fill: "#FFFFFF",
                align: "center"
            };
        } else {
            var textStyle = {
                font: global.fonts.main,
                fill: "#FFFFFF",
                align: "center"
            };
            var textStylePlay = {
                font: global.fonts.big,
                fill: "#FFFFFF",
                align: "center"
            };
        }

        var buttonPlay = this.add.button(-100, positions[0] - 30, 'PLAY_bt', this.clickStart, this);
        buttonPlay.anchor.set(0.5);
        buttonPlay.bringToTop();
        var textPlay = this.add.text(-100, positions[0] - 30 + 2, global.managers.language.get("Play"), textStylePlay);
        textPlay.anchor.set(0.5, 0.5);
        this.tweenTo(buttonPlay, this.world.width / 2, positions[0] - 30, true);
        this.tweenTo(textPlay, this.world.width / 2, positions[0] - 30 + 2, true);
        this.buttonPlay = buttonPlay;
        this.textPlay = textPlay;

        var buttonRules = this.game.add.button(this.world.width + 100, positions[1], 'bt_instruction_on', this.clickRules, this);
        buttonRules.anchor.set(0.5);
        var textRules = this.add.text(this.world.width + 100, positions[1] + 2, global.managers.language.get("Menu_btn_1"), textStyle);
        textRules.anchor.set(0.5, 0.5);
        this.tweenTo(buttonRules, this.world.width / 2, positions[1]);
        this.tweenTo(textRules, this.world.width / 2, positions[1] + 2);
        this.buttonRules = buttonRules;
        this.textRules = textRules;

        var buttonSettings = this.game.add.button(-100, positions[2], 'bt_instruction_on', this.clickSettings, this);
        buttonSettings.anchor.set(0.5);
        var textSettings = this.add.text(-100, positions[2] + 2, global.managers.language.get("OptionsKey"), textStyle);
        textSettings.anchor.set(0.5, 0.5);
        this.tweenTo(buttonSettings, this.world.width / 2, positions[2]);
        this.tweenTo(textSettings, this.world.width / 2, positions[2] + 2);
        this.buttonSettings = buttonSettings;
        this.textSettings = textSettings;

        var buttonAbout = this.game.add.button(this.world.width + 100, positions[3], 'bt_instruction_on', this.clickAbout, this);
        buttonAbout.anchor.set(0.5);
        var textAbout = this.add.text(this.world.width + 100, positions[3] + 2, global.managers.language.get("Instructions"), textStyle);
        textAbout.anchor.set(0.5, 0.5);
        this.tweenTo(buttonAbout, this.world.width / 2, positions[3]);
        this.tweenTo(textAbout, this.world.width / 2, positions[3] + 2);
        this.buttonAbout = buttonAbout;
        this.textAbout = textAbout;

        if (global.version != 2) {
            var buttonExit = this.game.add.button(this.world.width + 80, this.world.height + 80, 'bt_shutdown', this.clickExit, this);
            buttonExit.anchor.set(0.5);
            this.tweenTo(buttonExit, this.world.width - 40, this.world.height - 40);
            this.screenGroup.addChild(buttonExit);
        }

        // this.screenGroup.addChild(logo);
        this.screenGroup.addChild(buttonPlay);
        this.screenGroup.addChild(textPlay);
        this.screenGroup.addChild(buttonRules);
        this.screenGroup.addChild(textRules);
        this.screenGroup.addChild(buttonSettings);
        this.screenGroup.addChild(textSettings);
        this.screenGroup.addChild(buttonAbout);
        this.screenGroup.addChild(textAbout);
        this.screenGroup.visible = true;

        //playbutton tween
        this.playTween1 = this.game.add.tween(buttonPlay.scale).to({
            x: [1.05, 1],
            y: [1.05, 1]
        }, 600, Phaser.Easing.Linear.None, false, 0);
        this.playTween1.onComplete.add(function () {
            if (this.screenGroup.visible) {
                this.playTween2.start();
            }
        }, this);
        this.playTween2 = this.game.add.tween(buttonPlay.scale).to({
            x: [0.97, 1],
            y: [0.97, 1]
        }, 600, Phaser.Easing.Linear.None, false, 0);
        this.playTween2.onComplete.add(function () {
            if (this.screenGroup.visible) {
                this.playTween1.start();
            }
        }, this);

        this.playTween3 = this.game.add.tween(textPlay.scale).to({
            x: [1.05, 1],
            y: [1.05, 1]
        }, 600, Phaser.Easing.Linear.None, false, 0);
        this.playTween3.onComplete.add(function () {
            if (this.screenGroup.visible) {
                this.playTween4.start();
            }
        }, this);
        this.playTween4 = this.game.add.tween(textPlay.scale).to({
            x: [0.97, 1],
            y: [0.97, 1]
        }, 600, Phaser.Easing.Linear.None, false, 0);
        this.playTween4.onComplete.add(function () {
            if (this.screenGroup.visible) {
                this.playTween3.start();
            }
        }, this);

        this.add = false;
        this.add2 = false;

        this.updateTexts();

        if (global.storage.data.tutorial != 'done') {
            this.tutorialGroup = this.game.add.group();
            this.tutorialGroup.name = 'Tutorial';

            this.tutorial = new Tutorial(this.world, this.game);
            this.tutorial.showOverlay();
            this.tutorialGroup.addChild(buttonPlay);
            this.tutorialGroup.addChild(textPlay);

            global.createTimer(global.times.TUTORIAL_HAND_TIME - 10, function () {
                _this3.game.world.bringToTop(_this3.tutorialGroup);
                _this3.game.world.bringToTop(_this3.tutorial.getHand());
            });

            this.tutorial.createHand(this.world.width + 100, this.world.height + 100);
            if (global.resolution == "480x800") {
                this.tutorial.moveHandTo(this.world.width / 2 + 120, this.world.height / 2 + 95), global.times.TUTORIAL_HAND_TIME;
            } else {
                this.tutorial.moveHandTo(this.world.width / 2 + 175, positions[0] + 50), global.times.TUTORIAL_HAND_TIME;
            }

            this.tutorialGroup.addChild(this.tutorial.getHand());
        }

        var this1 = this;
        if (global.version != global.versions.HTML && global.inMenuListener == false) {
            global.inMenuListener = true;
            document.addEventListener("backbutton", function () {
                this1.androidBackHandler();
            }, false);
        }
    },

    androidBackHandler: function androidBackHandler() {
        console.log("Before -> "+ global.screen);
        switch (global.screen) {
            case -1:
                this.clickExit();
                break;
            case 0:
                this.savedGame.backBtnClicked();
                global.screen = -1;
                break;
            case 10:
                if(this.newGame == null){
                    this.savedGame.getNewGame().backBtnClicked();
                }else{
                    this.newGame.backBtnClicked();
                }
                global.screen = -1;
                break;
            case 1:
                this.screenRules.backBtnClicked();
                global.screen = -1;
                break;
            case 2:
                this.screenSettings.backBtnClicked();
                global.screen = -1;
                break;
            case 3:
                this.screenInstructions.backBtnClicked();
                global.screen = -1;
                break;
            case 4:
                this.exitScreen.noBtn();
                global.screen = 5;
                break;
        }
        console.log("After -> "+ global.screen);
    },

    tweenTo: function tweenTo(obj, desiredX, desiredY, end) {
        var time = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : this.TOP_CHECKERS_TWEEN_TIME;
        var linear = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : false;

        var _this = this;

        if (linear) {
            var tween = this.game.add.tween(obj).to({
                x: desiredX,
                y: desiredY
            }, time);
        } else {
            var tween = this.game.add.tween(obj).to({
                x: desiredX,
                y: desiredY
            }, time, "Quart.easeOut");
        }
        tween.start();
        if (end) {
            tween.onComplete.add(function () {
                _this.playTween1.start();
                _this.playTween3.start();
            });
        }
        return tween;
    },

    showMenuButtons: function showMenuButtons() {
        global.screen = -1;
        this.screenGroup.visible = true;
        this.logoGroup.visible = true;
        this.playTween1.start();
        this.playTween3.start();
        this.updateTexts();
    },

    clickStart: function clickStart() {
        global.managers.audio.playSound("click");
        if (global.storage.data.tutorial != 'done') {
            global.storage.data.board = null;
            global.storage.data.lastGameAi = null;
            global.storage.data.lastPlayer = null;

            global.storage.data.historyMoves = null;
            global.storage.data.removedCheckers = null;
            global.storage.data.historyBoardOfValues = null;
            if (this.tutorialGroup.length != 0) {
                this.tutorialGroup.visible = false;
                this.clickNewGame();
            }
        } else {
            if (global.storage.data.board != null) {
                global.screen = 0;
                if (this.savedGame == undefined || this.savedGame == null) {
                    this.savedGame = new ScreenSavedGame(this.game, this.world, this);
                }
                this.savedGame.showScreen();
                this.savedGameButtons = this.savedGame.getButtons();
                this.screenGroup.visible = false;
            } else {
                global.screen = 10;
                this.clickNewGame();
            }
        }
    },

    clickNewGame: function clickNewGame() {
        global.managers.audio.playSound("click");
        if (this.newGame == undefined || this.newGame == null) {
            this.newGame = new ScreenNewGame(this.game, this.world, this);
        }
        this.newGame.showScreen();
        this.newGameButtons = this.newGame.getButtons();

        this.screenGroup.visible = false;
    },

    clickRules: function clickRules() {
        console.log("click");
        
        global.screen = 1;
        global.managers.audio.playSound("click");
        this.logoGroup.visible = false;
        if (this.screenRules == undefined || this.screenRules == null) {
            this.screenRules = new ScreenRules(this.game, this.world, this);
        }
        this.screenRules.showScreen();
        this.screenGroup.visible = false;
    },

    clickSettings: function clickSettings() {
        global.screen = 2;
        global.managers.audio.playSound("click");
        this.logoGroup.visible = false;
        if (this.screenSettings == undefined || this.screenSettings == null) {
            this.screenSettings = new ScreenSettings(this.game, this.world, this);
        }
        this.screenSettings.showScreen();
        this.screenGroup.visible = false;
    },

    clickAbout: function clickAbout() {
        global.screen = 3;
        global.managers.audio.playSound("click");
        this.logoGroup.visible = false;
        if (this.screenInstructions == undefined || this.screenInstructions == null) {
            this.screenInstructions = new ScreenInstructions(this.game, this.world, this);
        }

        this.screenInstructions.showScreen();
        this.screenGroup.visible = false;
    },

    clickExit: function clickExit() {
        global.screen = 4;
        global.managers.audio.playSound("click");
        if (this.exitScreen == undefined || this.exitScreen == null) {

            this.exitScreen = new ScreenExit(this.game, this.world, this);
        }
        this.exitButtons = this.exitScreen.getButtons();
        this.exitScreen.showScreen();
        this.screenGroup.visible = false;
    },

    setNewGameButtons: function setNewGameButtons(buttons) {
        this.newGameButtons = buttons;
    },

    updateTexts: function updateTexts() {
        this.textPlay.setText(global.managers.language.get("Play"));
        this.textRules.setText(global.managers.language.get("Menu_btn_1"));
        this.textSettings.setText(global.managers.language.get("OptionsKey"));
        this.textAbout.setText(global.managers.language.get("Instructions"));
    }

};